/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2022 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "i2c.h"
#include "tim.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include <stdio.h>
#include <math.h>
#include "TM1637.h"
#include "TEA5767Radio.h"

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
uint8_t FM[1];
uint16_t frec =1053;
double freq = 105.3;
short int i=0, state0 =1, state1=1, state2=1, aux=0;
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_I2C1_Init();
  MX_TIM10_Init();
  /* USER CODE BEGIN 2 */
	
  HAL_TIM_Base_Start(&htim10); 
  TM1637_SetBrightness(7);
  TM1637_Init();
	HAL_I2C_Mem_Read(EEPROM_I2C, EEPROM_ADDR, 0, 2, FM, 1, 100); 
	
	if(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_12)==HIGH)  { //when aux =1 we can write on the eeprom, anyone frequency value.
		HAL_Delay(50);
		frec =880+FM[0];
		freq =frec*0.1;
		setFrequency(freq);
		TM1637_DisplayDecimal(frec, 0, DISABLE_ZEROS);
		aux=1; 
  }
	else {                        //when aux =0 we only can write on the eeprom, a frequency value = 105.3.
		HAL_Delay(50);              //you must use this mode when the eeprom at24c256 is new
		setFrequency(freq);
		TM1637_DisplayDecimal(frec, 0, DISABLE_ZEROS);
		aux=0;
	 }	
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
		
		 if(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_12)==LOW) {  
	        HAL_Delay(10); 
	       if(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_12)==LOW) state0=0, HAL_Delay(10);			 
   }
		  if( HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_12)==HIGH && state0==0) {
			 
			    frec--;
				  freq=freq-0.1;
			    if (frec < 880) frec = 1080;
				  if (freq < 88.0) freq = 108.0;						
			    setFrequency(freq);
		      TM1637_DisplayDecimal(frec, 0, DISABLE_ZEROS);
			    state0=1; 
		} 
			 if(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_13)==LOW) {  
	        HAL_Delay(10); 
	       if(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_13)==LOW) state1=0, HAL_Delay(10);			 
   }
		  if( HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_13)==HIGH && state1==0) {
			
			    frec++;
				  freq=freq+0.1;
			    if (frec > 1080) frec = 880;
          if (freq > 108.0) freq = 88.0;	 				 	
			    setFrequency(freq);
		      TM1637_DisplayDecimal(frec, 0, DISABLE_ZEROS);	
			    state1=1; 
		}
			
		if(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_14)==LOW) {  
	      HAL_Delay(10); 
	      if(HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_14)==LOW) state2=0, HAL_Delay(10);			 
   }
		  if( HAL_GPIO_ReadPin(GPIOB, GPIO_PIN_14)==HIGH && state2==0) {
					
		  if(aux==1) { 
				  FM[0]=frec-880; 
				  HAL_I2C_Mem_Write(EEPROM_I2C, EEPROM_ADDR, 0, 2, FM, 1, 100);
				}	
			else{ 
				FM[0]=173; //write the frequency value 105.3
				HAL_I2C_Mem_Write(EEPROM_I2C, EEPROM_ADDR, 0, 2, FM, 1, 100);
			}	
			for(i=0; i<=2; i++)	{
			   HAL_GPIO_WritePin(GPIOA, GPIO_PIN_8, HIGH);
			   HAL_Delay(200);
				 HAL_GPIO_WritePin(GPIOA, GPIO_PIN_8, LOW);
			   HAL_Delay(200);
			}	
			state2=1; 	

		}
		
  }
				
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLM = 12;
  RCC_OscInitStruct.PLL.PLLN = 96;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_3) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
